module Table where

import Data.List (intercalate)
import Text.Printf (printf)

data Alignment = AlignLeft | AlignRight

data TableOptions = TableOptions {
  separator  :: String
, cellWidths :: [Int]
, alignments :: [Alignment]
} 

renderLine :: TableOptions -> [String] -> String
renderLine TableOptions {separator = s, cellWidths = ws, alignments = as} =
  intercalate s . zipWith3 (\ w a -> printf (format w a)) ws as

  where format w a = "%" ++ formatAlignment a ++ show w ++ "s"
        formatAlignment AlignLeft  = "-"
        formatAlignment AlignRight = ""

headerSep :: TableOptions -> Char -> [String]
headerSep opts sep = map (flip replicate sep) $ cellWidths opts

renderTable :: TableOptions -> [[String]] -> String
renderTable opts = unlines . map (renderLine opts)
